package pcc.chemicraft;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.common.Configuration;
import net.minecraftforge.common.Property;
import pcc.chemicraft.block.BlockChemicalCombinationTable;
import pcc.chemicraft.block.BlockChemicalCraftingTable;
import pcc.chemicraft.block.BlockElectrolysisTable;
import pcc.chemicraft.block.BlockPyrolysisTable;
import pcc.chemicraft.block.BlockToolAndWeaponCraftingTable;
import pcc.chemicraft.compounds.CompoundDebug;
import pcc.chemicraft.compounds.CompoundWater;
import pcc.chemicraft.debug.CommandDeleteItem;
import pcc.chemicraft.debug.CommandGenDebugRoom;
import pcc.chemicraft.debug.CommandSetTile;
import pcc.chemicraft.gen.WorldGenAtomsOre;
import pcc.chemicraft.item.ItemAtoms;
import pcc.chemicraft.item.ItemAtomsGrenade;
import pcc.chemicraft.item.ItemCompounds;
import pcc.chemicraft.item.ItemGasCollectingBottle;
import pcc.chemicraft.ore.BlockAtomsOre;
import pcc.chemicraft.system.CommonProxy;
import pcc.chemicraft.system.PacketHandler;
import pcc.chemicraft.tileentity.TileEntityChemicalCombinationTable;
import pcc.chemicraft.tileentity.TileEntityChemicalCraftingTable;
import pcc.chemicraft.tileentity.TileEntityElectrolysisTable;
import pcc.chemicraft.tileentity.TileEntityPyrolysisTable;
import pcc.chemicraft.tileentity.TileEntityToolAndWeaponCraftingTable;
import pcc.chemicraft.util.Auxiliary;
import pcc.chemicraft.util.Auxiliary.ArrayAuxiliary;
import pcc.chemicraft.util.Auxiliary.NameAuxiliary;
import pcc.chemicraft.util.CreativeTabAtoms;
import pcc.chemicraft.util.NBTRecipeGrenade;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.SidedProxy;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.event.FMLServerStartingEvent;
import cpw.mods.fml.common.network.NetworkMod;
import cpw.mods.fml.common.network.NetworkRegistry;
import cpw.mods.fml.common.registry.GameRegistry;
/**
 * ChemiCraft本体
 * @author P.C.C.
 *
 */
@Mod(modid = "chemiCraft", name = "ChemiCraft", version = "beta")
@NetworkMod(clientSideRequired = true, serverSideRequired = true, versionBounds = "1.4.6", channels = "chemicraft", packetHandler = PacketHandler.class)
public class ChemiCraft {

	public static final String[] ATOMSNAME = {
		"Hydrogen", "Helium", "Lithium", "Beryllium", "Boron", "Carbon", "Nitrogen", "Oxygen", "Fluorine", "Neon", "Sodium", "Magnesium", "Aluminium", "Silicon",
		"Phosphorus", "Sulfur", "Chlorine", "Argon", "Potassium", "Calcium", "Scandium", "Titanium", "Vanadium", "Chromium", "Manganese", "Iron", "Cobalt", "Nickel", "Copper", "Zinc", "Gallium",
		"Germanium", "Arsenic", "Selenium", "Bromine", "Krypton", "Rubidium", "Strontium", "Yttorium", "Zirconium", "Niobium", "Molybdenum", "Technetium", "Ruthenium", "Rhodium", "Palladium",
		"Silver", "Cadmium", "Indium", "Tin", "Antimony", "Tellurium", "Iodine", "Xenon", "Caesium", "Barium", "Lanthanum", "Cerium", "Praseodymium", "Neodymium", "Promethium", "Samarium",
		"Europium", "Gadolinium", "Terbium", "Dysprosium", "Holmium", "Erbium", "Thulium", "Ytterbium", "Lutetium", "Hafnium", "Tantalum", "Tungsten", "Rhenium", "Osmium", "Iridium", "Platinum",
		"Gold", "Mercury", "Thallium", "Lead", "Bismuth", "Polonium", "Astatine", "Radon", "Francium", "Radium", "Actinium", "Thorium", "Protactinium", "Uranium", "Neptunium", "Plutonium",
		"Americium", "Curium", "Berkelium", "Californium", "Einsteinium", "Fermium", "Mendelevium", "Nobelium", "Lawrencium", "Rutherfordium", "Dubnium", "Seaborgium", "Bohrium", "Hassium",
		"Meitnerium", "Darmstadtium", "Roentgenium", "Copernicium", "Ununtrium", "Ununquadium", "Ununpentium", "Ununhexium", "Ununseptium", "Ununoctium" };

	public static final String[] ATOMSNAMEJP = {
		"水素", "ヘリウム", "リチウム", "ベリウム", "ホウ素", "炭素", "窒素", "酸素", "フッ素", "ネオン", "ナトリウム", "マグネシウム", "アルミニウム", "ケイ素", "リン", "硫黄", "塩素", "アルゴン", "カリウム", "カルシウム", "スカンジウム",
		"チタン", "バナジウム", "クロム", "マンガン", "鉄", "コバルト", "ニッケル", "銅", "亜鉛", "ガリウム", "ゲルマニウム", "ヒ素", "セレン", "臭素", "クリプトン", "ルビジウム", "ストロンチウム", "イットリウム", "ジルコニウム", "ニオブ", "モリブデン", "テクネチウム", "ルテニウム",
		"ロジウム", "パラジウム", "銀", "カドミウム", "インジウム", "スズ", "アンチモン", "テルル", "ヨウ素", "キセノン", "セシウム", "バリウム", "ランタン", "セリウム", "プラセオジム", "ネオジム", "プロメチウム", "サマリウム", "ユウロビウム", "ガドリニウム", "テルビウム", "ジスプロニウム",
		"ホルミウム", "エルビウム", "ツリウム", "イッテルビウム", "ルテチウム", "ハフニウム", "タンタル", "タングステン", "レニウム", "オスミウム", "イリジウム", "白金", "金", "水銀", "タリウム", "鉛", "ビスマス", "ポロニウム", "アスタチン", "ラドン", "フランシウム", "ラジウム",
		"アクチニウム", "トリウム", "プロトアクチウム", "ウラン", "ネプツニウム", "プルトニウム", "アメリシウム", "キュリウム", "バークリウム", "カルホルニウム", "アインスタイニウム", "フェルミウム", "メンデレビウム", "ノーベリウム", "ローレンシウム", "ラサホージウム", "ドブニウム", "シーボーギウム",
		"ボーリウム", "ハッシウム", "マイトネリウム", "ダームスタチウム", "レントゲニウム", "コペルニシウム", "ウンウントリウム", "ウンウンクアジウム", "ウンウンペンチウム", "ウンウンヘキシウム", "ウンウンセプチウム", "ウンウンオクチウム" };

	/**
	 * このmodのインスタンス
	 */
	@Mod.Instance("chemiCraft")
	public static ChemiCraft instance;

	/**
	 * ChemiCraftのProxy.
	 */
	@SidedProxy(clientSide = "pcc.chemicraft.client.ClientProxy", serverSide = "pcc.chemicraft.system.CommonProxy")
	public static CommonProxy proxy;

	/**
	 * ChemiCraftのCreativeTab.
	 */
	public static final CreativeTabs creativeTab = new CreativeTabAtoms("ChemiCraft");

	/**
	 * ItemID.
	 */
	public int atomsID;
	public int compoundsID;
	public int gasCollectingBottleID;
	public int atomGrenadeID;

	/**
	 * BlockID.
	 */
	public int pyrolysisTableID;
	public int electrolysisTableID;
	public int chemicalConbinationTableID;
	public int toolAndWeaponCraftingTableID;
	public int chemicalCraftingTableID;

	public int atomsOreID;

	/**
	 * GUIID.
	 */
	public int guiPyrolysisTableID;
	public int guiElectrolysisTableID;
	public int guiChemicalCombinationTableID;
	public int guiToolAndWeaponCraftingTableID;
	public int guiChemicalCraftingTableID;

	/**
	 * Block型変数.
	 */
	public Block blockPyrolysisTable;
	public Block blockElectrolysisTable;
	public Block blockChemicalCombinationTable;
	public Block blockToolAndWeaponCraftingTable;
	public Block blockChemicalCraftingTable;

	public Block blockAtomsOre;

	/**
	 * Item型変数.
	 */
	public Item itemAtoms;
	public Item itemCompounds;
	public Item itemGasCollectingBottle;
	public Item itemAtomGrenade;

	/**
	 * このmodで使用するTextureのパス.
	 */
	public final String ITEM_ATOMS_TEXTURE = "/pcc/chemicraft/items/Atoms.png";
	public final String ITEM_COMPOUNDS_TEXTURE = "/pcc/chemicraft/items/Compounds.png";
	public final String ITEM_TEXTURE = "/pcc/chemicraft/items/items.png";
	public final String BLOCK_CHEMICAL_CRAFTING_TABLE_TEXTURE = "/pcc/chemicraft/blocks/cctable.png";
	public final String BLOCK_ATOMS_ORE_TEXTURE = "/pcc/chemicraft/blocks/AtomsOres.png";
	public final String GUI_PYROLYSIS_TEXTURE = "/pcc/chemicraft/guis/Pyrolysis.png";
	public final String GUI_ELECTROLYSIS_TEXTURE = "/pcc/chemicraft/guis/Electrolysis.png";
	public final String GUI_CHEMICALCOMBINATION_TEXTURE = "/pcc/chemicraft/guis/ChemicalCombination.png";
	public final String GUI_TOOLANDWEAPONCRAFTING_TEXTURE = "/pcc/chemicraft/guis/ToolAndWeaponCrafting.png";
	public final String GUI_CHEMICALCRAFTING_TEXTURE = "/pcc/chemicraft/guis/MaterialCrafting.png";

	/**
	 * このmodに必要な補助クラスのインスタンス.
	 */
	public Auxiliary auxiliary = new Auxiliary();
	public NameAuxiliary nameAuxiliary = new NameAuxiliary();
	public ArrayAuxiliary arrayAuxiliary = new ArrayAuxiliary();

	private ChemiCraftAPI api = ChemiCraftAPI.instance();
	private ChemiCraftData chemicalData = new ChemiCraftData();

	@Mod.PreInit
	public void chemiPreLoadMethod(final FMLPreInitializationEvent event) {
		Configuration cfg = new Configuration(event.getSuggestedConfigurationFile());
		cfg.load();

		Property pyrolysisTableIDProp = cfg.getBlock("PyrolysisTable", 2400);
		Property electrolysisTableIDProp = cfg.getBlock("ElectrolysisTable", 2401);
		Property chemicalCombinationTableIDProp = cfg.getBlock("ChemicalCombinationID", 2402);
		Property toolAndWeaponCraftingTableIDProp = cfg.getBlock("ToolAndWeaponCraftingTableID", 2403);
		Property chemicalCraftingTableIDProp = cfg.getBlock("ChemicalCraftingTableID", 2404);

		Property atomsOreIDProp = cfg.getBlock("AtomsOreID", 2500);

		Property atomsIDProp = cfg.getItem("AtomsID", 25000);
		Property compoundsIDProp = cfg.getItem("CompoundsID", 25001);
		Property gasCollectingBottleIDProp = cfg.getItem("gasCollectingBottleID", 25002);
		Property atomGrenadeIDProp = cfg.getItem("AtomGrenadeID", 25003);

		Property guiPyrolysisTableIDProp = cfg.get("GUI", "GUIPyrolysisID", 1000);
		Property guiElectrolysisTableIDProp = cfg.get("GUI", "GUIElectrolysisTableIDProp", 1001);
		Property guiChemicalCombinationTableIDProp = cfg.get("GUI", "GUIChemicalCombinationTableID", 1002);
		Property guiToolAndWeaponCraftingTableIDProp = cfg.get("GUI", "GUIToolAndWeaponCraftingTableID", 1003);
		Property guiChemicalCraftingTableIDProp = cfg.get("GUI", "GUIChemicalCraftingTableID", 1004);


		this.pyrolysisTableID = pyrolysisTableIDProp.getInt();
		this.electrolysisTableID = electrolysisTableIDProp.getInt();
		this.chemicalConbinationTableID = chemicalCombinationTableIDProp.getInt();
		this.toolAndWeaponCraftingTableID = toolAndWeaponCraftingTableIDProp.getInt();
		this.chemicalCraftingTableID = chemicalCraftingTableIDProp.getInt();
		this.atomsOreID = atomsOreIDProp.getInt();
		this.atomsID = atomsIDProp.getInt();
		this.compoundsID = compoundsIDProp.getInt();
		this.gasCollectingBottleID = gasCollectingBottleIDProp.getInt();
		this.atomGrenadeID = atomGrenadeIDProp.getInt();
		this.guiPyrolysisTableID = guiPyrolysisTableIDProp.getInt();
		this.guiElectrolysisTableID = guiElectrolysisTableIDProp.getInt();
		this.guiChemicalCombinationTableID = guiChemicalCombinationTableIDProp.getInt();
		this.guiToolAndWeaponCraftingTableID = guiToolAndWeaponCraftingTableIDProp.getInt();
		this.guiChemicalCraftingTableID = guiChemicalCraftingTableIDProp.getInt();

		cfg.save();
	}

	@Mod.ServerStarting
	public void serverStarting(final FMLServerStartingEvent event) {
		event.registerServerCommand(new CommandSetTile());
		event.registerServerCommand(new CommandDeleteItem());
		event.registerServerCommand(new CommandGenDebugRoom());
	}

	@Mod.PostInit
	public void chemiPostLoadMethod(final FMLPostInitializationEvent event) {
		this.settingProcessing(event);
		this.apiProcessing(event);
		this.debug(event);
	}

	private void settingProcessing(final FMLPostInitializationEvent event) {

		// Blockを追加します
		this.blockPyrolysisTable = new BlockPyrolysisTable(this.pyrolysisTableID, 0, Material.ground).
				setHardness(2.0F).
				setResistance(0.0F).
				setStepSound(Block.soundStoneFootstep).
				setBlockName("PyrolysisTable");
		this.blockElectrolysisTable = new BlockElectrolysisTable(this.electrolysisTableID, 0, Material.ground).
				setHardness(2.0F).
				setResistance(0.0F).
				setStepSound(Block.soundStoneFootstep).
				setBlockName("ElectrolysisTable");
		this.blockChemicalCombinationTable = new BlockChemicalCombinationTable(this.chemicalConbinationTableID, 0, Material.ground).
				setHardness(2.0F).
				setResistance(0.0F).
				setStepSound(Block.soundStoneFootstep).
				setBlockName("ChemicalCombinationTable");
		this.blockToolAndWeaponCraftingTable = new BlockToolAndWeaponCraftingTable(this.toolAndWeaponCraftingTableID, 0, Material.ground).
				setHardness(2.0F).
				setResistance(0.0F).
				setStepSound(Block.soundStoneFootstep).
				setBlockName("ToolAndWeaponCraftingTable");
		this.blockChemicalCraftingTable = new BlockChemicalCraftingTable(this.chemicalCraftingTableID, 0, Material.ground).
				setHardness(2.0F).
				setResistance(0.0F).
				setStepSound(Block.soundStoneFootstep).
				setBlockName("ChemicalCraftingTable");

		// Itemを追加します
		this.itemAtoms = new ItemAtoms(this.atomsID).setItemName("atoms");
		this.itemCompounds = new ItemCompounds(this.compoundsID).setItemName("compounds");
		this.itemGasCollectingBottle = new ItemGasCollectingBottle(this.gasCollectingBottleID).setItemName("gasCollectingBottle").setIconIndex(0);
		this.itemAtomGrenade = new ItemAtomsGrenade(this.atomGrenadeID).setItemName("grenade").setIconIndex(1);

		// BlockをMinecraftに登録します
		GameRegistry.registerBlock(this.blockPyrolysisTable, "BlockPyrolysisTable");
		GameRegistry.registerBlock(this.blockChemicalCombinationTable, "BlockChemicalCombinationTable");
		GameRegistry.registerBlock(this.blockToolAndWeaponCraftingTable, "BlockToolAndWeaponCraftingTable");
		GameRegistry.registerBlock(this.blockChemicalCraftingTable, "BlockMaterialCraftingTable");
		GameRegistry.registerBlock(this.blockElectrolysisTable, "BlockElectrolysisTable");

		// Blockの名前を設定します
		this.nameAuxiliary.addName(this.blockPyrolysisTable, "PyrolysisTable");
		this.nameAuxiliary.addName(this.blockPyrolysisTable, "ja_JP", "熱分解台");
		this.nameAuxiliary.addName(this.blockChemicalCombinationTable, "ChemicalCombinationTable");
		this.nameAuxiliary.addName(this.blockChemicalCombinationTable, "ja_JP", "化合台");
		this.nameAuxiliary.addName(this.blockToolAndWeaponCraftingTable, "ToolAndWeaponCraftingTable");
		this.nameAuxiliary.addName(this.blockToolAndWeaponCraftingTable, "ja_JP", "ツール&武器製作台");
		this.nameAuxiliary.addName(this.blockChemicalCraftingTable, "ChemicalCraftingTable");
		this.nameAuxiliary.addName(this.blockChemicalCraftingTable, "ja_JP", "素材製作台");
		this.nameAuxiliary.addName(this.blockElectrolysisTable, "ElectrolysisTable");
		this.nameAuxiliary.addName(this.blockElectrolysisTable, "ja_JP", "電気分解台");

		// Itemの名前を設定します
		this.nameAuxiliary.addName(this.itemAtoms, ATOMSNAME);
		this.nameAuxiliary.addName(this.itemAtoms, "ja_JP", ATOMSNAMEJP);
		this.nameAuxiliary.addName(this.itemGasCollectingBottle, "GasCollectingBottle");
		this.nameAuxiliary.addName(this.itemGasCollectingBottle, "ja_JP", "集気瓶");
		this.nameAuxiliary.addName(this.itemAtomGrenade, "AtomGrenade");
		this.nameAuxiliary.addName(this.itemAtomGrenade, "元素手榴弾");

		// TileEntityを追加します
		GameRegistry.registerTileEntity(TileEntityPyrolysisTable.class, "TileEntityPyrolysisTable");
		GameRegistry.registerTileEntity(TileEntityChemicalCombinationTable.class, "TileEntityChemicalCombinationTable");
		GameRegistry.registerTileEntity(TileEntityToolAndWeaponCraftingTable.class, "TileEntityToolAndWeaponCraftingTable");
		GameRegistry.registerTileEntity(TileEntityChemicalCraftingTable.class, "TileEntityChemicalCraftingTable");
		GameRegistry.registerTileEntity(TileEntityElectrolysisTable.class, "TileEntityElectrolysisTable");

		// GUIを追加します
		NetworkRegistry.instance().registerGuiHandler(instance, proxy);

		// 描画関係の読み込み
		proxy.registerRenderInformation();

		//化学作業台類のレシピを追加します
		GameRegistry.addRecipe(new ItemStack(this.blockPyrolysisTable),
				new Object[]{
			"XYX", "ZAZ", "ZZZ",
			Character.valueOf('X'), new ItemStack(Item.ingotIron),
			Character.valueOf('Y'), new ItemStack(Block.workbench),
			Character.valueOf('Z'), new ItemStack(Block.stone),
			Character.valueOf('A'), new ItemStack(Item.bucketLava),
		});
		GameRegistry.addRecipe(new ItemStack(this.blockChemicalCombinationTable),
				new Object[]{
			"XYX", "ZAZ", "ZZZ",
			Character.valueOf('X'), new ItemStack(Item.ingotIron),
			Character.valueOf('Y'), new ItemStack(Block.workbench),
			Character.valueOf('Z'), new ItemStack(Block.stone),
			Character.valueOf('A'), new ItemStack(Block.obsidian),
		});
		GameRegistry.addRecipe(new ItemStack(this.blockToolAndWeaponCraftingTable),
				new Object[]{
			"XYX", "ZAZ", "ZZZ",
			Character.valueOf('X'), new ItemStack(Item.ingotIron),
			Character.valueOf('Y'), new ItemStack(Block.workbench),
			Character.valueOf('Z'), new ItemStack(Block.stone),
			Character.valueOf('A'), new ItemStack(Item.pickaxeSteel),
		});
		GameRegistry.addRecipe(new ItemStack(this.blockChemicalCraftingTable),
				new Object[]{
			"XYX", "ZAZ", "ZZZ",
			Character.valueOf('X'), new ItemStack(Item.ingotIron),
			Character.valueOf('Y'), new ItemStack(Block.workbench),
			Character.valueOf('Z'), new ItemStack(Block.stone),
			Character.valueOf('A'), new ItemStack(this.itemAtoms, 1, 0),
		});

		//鉱石の登録
		for (int i = 0; i < api.getAtomsOreIDList().size(); i++) {
			this.blockAtomsOre = new BlockAtomsOre(api.getAtomsOreIDList().get(i)).
					setHardness(3.0F).setResistance(5.0F).
					setStepSound(Block.soundStoneFootstep).
					setBlockName("AtomsOre" + "." + api.getAtomsOreIDList().get(i));
			GameRegistry.registerBlock(this.blockAtomsOre, "AtomsOre");
		}

		//鉱石を追加します
		api.addAtomsOre("Test", Block.blockDiamond.blockID, 0, 5, 5, 20); //テスト用

		//鉱石の生成
		for (int i = 0; i < api.getAtomsOreIDList().size(); i++) {
			GameRegistry.registerWorldGenerator(new WorldGenAtomsOre(api.getAtomsOreIDList().get(i), api.getAtomsOreMetaList().get(i), api.getAtomsOreSizeList().get(i), api.getAtomsOreFrequencyList().get(i), api.getAtomsOrePosYList().get(i)));
		}

		//化合物を追加します
		api.addLangCompound("ja_JP", "ChlorousAcid", "亜塩素酸");

		api.addLangCompound("ja_JP", "CarbonMonoxide", "一酸化炭素");
		api.addLangCompound("ja_JP", "CarbonDioxide", "二酸化炭素");
		api.addLangCompound("ja_JP", "Water", "水");


		//化合物のHandlerを設定します
		api.settingCompoundHandler("Water", new CompoundWater());

		//化合物のレシピを追加します
		api.addChemicalCombinationRecipe(new String[]{"H", "O", "Cl"}, new Integer[]{1, 2, 1}, new ItemStack(this.itemCompounds, 1, api.getCompound("ChlorousAcid")));

		api.addChemicalCombinationRecipe(new String[]{"H", "O"}, new Integer[]{2, 1}, new ItemStack(this.itemCompounds, 1, api.getCompound("Water")));

		//手榴弾の追加
		api.addMaterialRecipe(new ItemStack[] {
				null,
				new ItemStack(Block.stone),
				null,
				new ItemStack(Block.stone),
				new ItemStack(Item.gunpowder),
				new ItemStack(Block.stone),
				null,
				new ItemStack(Block.stone),
				null
		},
		new ItemStack(this.itemAtomGrenade, 16, 0),
		new NBTRecipeGrenade()
				);

		api.addDecompositionRecipe(new ItemStack(Item.potion, 1, 0),
				new int[] {ChemiCraftData.HYDROGEN, ChemiCraftData.OXYGEN},
				new int[] {2, 1});

		api.addDecompositionRecipe(new ItemStack(this.itemCompounds, 1, api.getCompound("Water")),
				new int[] {ChemiCraftData.HYDROGEN, ChemiCraftData.OXYGEN},
				new int[] {2, 1});

		api.addDecompositionFuel(new ItemStack(Item.coal), 2000*8);
	}

	private void apiProcessing(final FMLPostInitializationEvent event) {
		// API用の処理
		this.nameAuxiliary.addName(itemCompounds, api.getCompoundsName().toArray());
		for (int i = 0; i < api.getCompoundsLang().size(); i++) {
			this.nameAuxiliary.addName(itemCompounds, api.getCompoundsLang().get(i), api.getCompoundsLangName().toArray());
		}
	}

	private void debug(final FMLPostInitializationEvent event) {
		//DebugTickingの追加
		this.proxy.registerTickHandler();
		this.api.addCompound("Debug");
		this.api.settingCompoundHandler("Debug", new CompoundDebug());

		/*
		 * TWDebug
		 */
		api.addToolAndWeaponRecipe(new ItemStack[] {
				new ItemStack(Block.stone, 1, 1)
		},
		new ItemStack(Block.dirt, 1, 0));
	}

}
