package pcc.chemicraft.system;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;
import pcc.chemicraft.container.ContainerChemicalCombinationTable;
import pcc.chemicraft.container.ContainerChemicalCraftingTable;
import pcc.chemicraft.container.ContainerPyrolysisTable;
import pcc.chemicraft.container.ContainerToolAndWeaponCraftingTable;
import pcc.chemicraft.debug.DebugTick;
import pcc.chemicraft.tileentity.TileEntityChemicalCombinationTable;
import pcc.chemicraft.tileentity.TileEntityChemicalCraftingTable;
import pcc.chemicraft.tileentity.TileEntityPyrolysisTable;
import pcc.chemicraft.tileentity.TileEntityToolAndWeaponCraftingTable;
import cpw.mods.fml.common.network.IGuiHandler;
import cpw.mods.fml.common.registry.TickRegistry;
import cpw.mods.fml.relauncher.Side;

public class CommonProxy implements IGuiHandler {

	public void registerTextures(){

	}

	public void registerRenderInformation() {
	}


	@Override
	public Object getServerGuiElement(int ID, EntityPlayer player, World world, int x, int y, int z) {
		if (!world.blockExists(x, y, z))
			return null;

		TileEntity tileEntity = world.getBlockTileEntity(x, y, z);
		if (tileEntity instanceof TileEntityPyrolysisTable) {
			return new ContainerPyrolysisTable(player, (TileEntityPyrolysisTable) tileEntity);
		}else if(tileEntity instanceof TileEntityChemicalCombinationTable){
			return new ContainerChemicalCombinationTable(player, (TileEntityChemicalCombinationTable) tileEntity);
		}else if(tileEntity instanceof TileEntityToolAndWeaponCraftingTable){
			return new ContainerToolAndWeaponCraftingTable(player, (TileEntityToolAndWeaponCraftingTable) tileEntity);
		}else if(tileEntity instanceof TileEntityChemicalCraftingTable){
			return new ContainerChemicalCraftingTable(player, (TileEntityChemicalCraftingTable) tileEntity);
		}
		return null;
	}


	@Override
	public Object getClientGuiElement(int ID, EntityPlayer player, World world, int x, int y, int z) {
		return null;
	}

	public World getClientWorld(){
		return null;
	}

	public void registerTickHandler() {
		TickRegistry.registerTickHandler(new DebugTick(), Side.SERVER);
	}

}